--- libmad-0.15.1b-old/configure	2013-11-03 00:54:06.000000000 +0900
+++ libmad-0.15.1b-new/configure	2015-01-11 15:47:17.000000000 +0900
@@ -19083,7 +19083,7 @@
     then
 	case "$host" in
 	    i386-*)           ;;
-	    i?86-*)           arch="-march=i486" ;;
+#	    i?86-*)           arch="-march=i486" ;;
 	    arm*-empeg-*)     arch="-march=armv4 -mtune=strongarm1100" ;;
 	    armv4*-*)         arch="-march=armv4 -mtune=strongarm" ;;
 	    powerpc-*)        ;;

--- libmad-0.15.1b-old/fixed.h	2013-11-03 00:50:30.000000000 +0900
+++ libmad-0.15.1b-new/fixed.h	2015-01-12 20:42:18.000000000 +0900
@@ -26,7 +26,11 @@
 typedef   signed int mad_fixed_t;
 
 typedef   signed int mad_fixed64hi_t;
+#if defined(FPM_ARM) && defined(__aarch64__)
+typedef unsigned long mad_fixed64lo_t;
+#else
 typedef unsigned int mad_fixed64lo_t;
+#endif
 # else
 typedef   signed long mad_fixed_t;
 
@@ -239,7 +243,7 @@
 
 /* --- ARM ----------------------------------------------------------------- */
 
-# elif defined(FPM_ARM)
+# elif defined(FPM_ARM) && !defined(__aarch64__)
 
 /* 
  * This ARM V4 version is as accurate as FPM_64BIT but much faster. The
@@ -455,6 +459,16 @@
 
 /* ------------------------------------------------------------------------- */
 
+# elif defined(FPM_ARM) && defined(__aarch64__)
+
+#define OPT_SSO
+
+#define mad_f_mul(x, y) ((((long)(x))*(y))>>28)
+#define MAD_F_MLX(hi, lo, x, y) {lo = ((long)(x))*(y);}
+#define MAD_F_MLA(hi, lo, x, y) {lo += ((long)(x))*(y);}
+#define mad_f_scale64(hi, lo)  ((lo)>>28)
+#define MAD_F_SCALEBITS  MAD_F_FRACBITS
+
 # else
 #  error "no FPM selected"
 # endif
